import {getDatabase} from './getDB';
import {databaseConf, possibleDBKeys} from './types';

export interface filterParam {
  type: 'name';
}

export const getEntry = async <T2 extends databaseConf<T, any>, T>(
  schema: T2,
  key: possibleDBKeys,
): Promise<null | T> => {
  const dbName = schema.details.name;
  const realm = await getDatabase(dbName);

  const val = realm.objectForPrimaryKey<typeof schema.details.properties>(
    dbName,
    key,
  );

  return val as T;
};

export const getAllEntries = async <T2 extends databaseConf<T, any>, T>(
  schema: T2,
  filter?: filterParam,
): Promise<null | T[]> => {
  const dbName = schema.details.name;
  const realm = await getDatabase(dbName);

  const val = realm.objects<typeof schema.details.properties>(dbName);

  return [...val] as T[];
};
