import {filterParam} from './get';

export type databaseNames = 'users' | 'chat' | 'chatRoomInfos';
export type possibleDBKeys = string;

export interface databaseConf<props, enums> {
  filePath: string;
  version: number;
  migration?: any;
  keys: enums;
  getEntry: (key: possibleDBKeys) => Promise<props | null>;
  getAllEntries: (filter?: filterParam) => Promise<props[] | null>;
  setEntry: (val: props) => Promise<void>;
  defaultProps: props;
  details: {
    name: databaseNames;
    properties: {[key in keyof props]: string};
    primaryKey: keyof props;
  };
}
